import os
from pathlib import Path
from flask import jsonify

from atlaz.io_operations.file_mediator import build_directory_tree_json, make_paths_relative

def handle_get_directory_tree():
    root_path = Path.cwd()
    ignore_items = {'__pycache__', 'node_modules', '.git', '.venv', 'venv', 'build', 'dist', 'atlaz.egg-info','atlaz_overview.txt', 'LICENSE', 'MANIFEST.in'}
    default_unmarked = ['.gitignore', 'docker-compose.yml', '__pycache__', 'x_deploy.md', 'tests', 'setup.cfg', 'prompts', 'old_files', 'pyproject.toml', 'requirements.txt', 'setup.cfg', 'prompts', 'start_servers.py', 'overview.py', 'overview_test.py', 'testing2.py']
    tree_json = build_directory_tree_json(root_path, ignore=ignore_items, max_depth=20)
    tree_json_relative = make_paths_relative(tree_json, root_path)
    return jsonify({
        "tree": tree_json_relative,
        "default_unmarked": default_unmarked
    })